

//limited at 10 because deaths change color as they get older,
//and I can only have "\c$N" 10 colors
//not a good idea to change this
$survival_map_max_deaths = 10;

function reExecSurvivalMap()
{
	discoverFile("Add-ons/Client_Survival_Map.zip");
	exec("Add-ons/Client_Survival_Map/client.cs");
}

package SurvivalMap
{
	function handleYourDeath(%msgType, %msgString, %yourName, %killerName, %respawnTime)
	{
		survival_addDeathPosition($SurvivalMap_last_good_position);
		return Parent::handleYourDeath(%msgType, %msgString, %yourName, %killerName, %respawnTime);
	}

};
activatePackage(SurvivalMap);

exec("./client.gui");

function survival_map_deleteAllDeaths()
{
	$survival_map_deathCount = 0;
	for(%a = 0; %a < $survival_map_max_deaths; %a++)
	{
		%d = $survival_map_death[%a];
		if(isObject(%d))
			%d.delete();
	}
}
survival_map_deleteAllDeaths();

if($survival_map_max_deaths > 10)
	$survival_map_max_deaths = 10;


function survival_addDeathPosition(%pos)
{
	if($survival_map_deathCount == $survival_map_max_deaths)
	{
		//delete dot associated with the oldest death
		$survival_map_death[0].delete();

		//move all deaths down one position
		for(%a = 1; %a < $survival_map_max_deaths; %a++)
			$survival_map_death[%a - 1] = $survival_map_death[%a];

		$survival_map_deathCount--;
	}

	SurvivalMap.add($survival_map_death[$survival_map_deathCount] =
	new GuiTextCtrl()
	{
	   //I don't even use these...
	   deathPos = %pos;
	   deathTime = getSimTime();

	   profile = "SurvivalMapDeathDotProfile";
	   horizSizing = "right";
	   vertSizing = "bottom";
	   position = survival_getDotPos(%pos);
	   extent = "12 72";
	   minExtent = "12 72";
	   visible = "1";
	   clipToParent = "1";
	   text = "";
	   maxLength = "255";
	});

	$survival_map_deathCount++;
	for(%a = 0; %a < $survival_map_deathCount; %a++)
	{
		%whichColor = $survival_map_deathCount - %a - 1;
		eval("%text = \"\\c"@ (%whichColor) @".\";");
		$survival_map_death[%a].setText(%text);
	}

	//keep the location dot on top, and the dir dot on top of that
	SurvivalMap.pushToBack(SurvivalMapLocationDot);
	SurvivalMap.pushToBack(SurvivalMapDirDot);

	for(%i = 0; %i < $survival_map_dirDotCount; %i++)
		if(isObject(%d = $survival_map_dirdot[%i]))
			SurvivalMap.pushToBack(%d);
}

function SurvivalMap_position_loop()
{
	%sc = serverConnection;

	if(!isObject(%sc))
	{
		//no longer or not connected to a server, so stop looking for a position
		$SurvivalMap_position_schedule = schedule(10000, 0, SurvivalMap_position_loop);
		if($survival_map_deathCount > 0)
			survival_map_deleteAllDeaths();
		return;
	}

	if(!isObject(%scgco = %sc.getControlObject()))
	{
		//loading but not yet spawned
		$SurvivalMap_position_schedule = schedule(5000, 0, SurvivalMap_position_loop);
		if($survival_map_deathCount > 0)
			survival_map_deleteAllDeaths();
		return;
	}

	if((%pos = %scgco.getPosition()) !$= "")
	{
		$SurvivalMap_last_good_position = %pos;
		$SurvivalMap_last_good_direction = %scgco.getForwardVector();
	}
	$SurvivalMap_position_schedule = schedule(5000, 0, SurvivalMap_position_loop);
}

cancel($SurvivalMap_position_schedule);
SurvivalMap_position_loop();

$survival_last_show_time = 0;
$survival_map_mapped = 0;

$survival_map_last_press_time = 0;
$survival_map_doubletap_time = 500;
$survival_map_ignore_depress = 0;
$survival_map_deathCount = 0;

if($survival_map_mapped != 1)
{
	$remapDivision[$remapCount] = "Survival Map";


	$remapName[$remapCount] = "Show map";
	$remapCmd[$remapCount] = "survival_map_on";
	$remapCount++;

	$survival_map_mapped = 1;
}

function adjustSurvivalMapPos()
{
	%pg_ext = PlayGUI.extent;
	%pg_ext_x = getWord(%pg_ext, 0);
	%pg_ext_y = getWord(%pg_ext, 1);

	%img_ext = "396 275";
	%img_ext_x = getWord(%img_ext, 0);
	%img_ext_y = getWord(%img_ext, 1);

	%img_pos_x = mFloatLength((%pg_ext_x - %img_ext_x) / 2, 0);
	%img_pos_y = mFloatLength((%pg_ext_y - %img_ext_y) / 2, 0);

	SurvivalMap.extent = %img_ext;
	SurvivalMap.position = %img_pos_x SPC %img_pos_y;
}


function rotatePointXY(%pt, %ang)
{
	%pos_x = getWord(%pt, 0);
	%pos_y = getWord(%pt, 1);
	%pos_z = getWord(%pt, 2); //z remains the same

	%len = vectorLen(%pos_x SPC %pos_y);
	%angle_orig = mAtan(%pos_y, %pos_x);

	%angle = %angle_orig + mDegToRad(%ang);

	%pos_x_rot = mCos(%angle) * %len;
	%pos_y_rot = mSin(%angle) * %len;

	return %pos_x_rot SPC %pos_y_rot SPC %pos_z;
}

function survival_getDotPos(%curpos)
{
	//rotate all positions 135 degrees clockwise to get their
	//"equivalent" on the isometric image
	%point0 = "-458.5 -906 8"; //northwestern most part of map
	%point0_img = 116 SPC 2;
	%point0_rot = rotatePointXY(%point0, -135);

	%point1 = "342 501 8"; //military base southeast corner
	%point1_img = 218 SPC 251;
	%point1_rot = rotatePointXY(%point1, -135);

	%point0_rot_x = getWord(%point0_rot, 0);
	%point0_rot_y = getWord(%point0_rot, 1);

	%point_diff = vectorSub(%point1_rot, %point0_rot);
	%point_diff_x = getWord(%point_diff, 0);
	%point_diff_y = getWord(%point_diff, 1);



	%pos_rot = rotatePointXY(%curpos, -135);

	%pos_x = %pos_x_rot = getWord(%pos_rot, 0);
	%pos_y = %pos_y_rot = getWord(%pos_rot, 1);
	%pos_z = getWord(%pos_rot, 2);

	%x_diff = (%pos_x_rot - %point0_rot_x);
	%y_diff = (%pos_y_rot - %point0_rot_y);

	%z_diff = %pos_z - 8;

	%point0_img_x = getWord(%point0_img, 0);
	%point0_img_y = getWord(%point0_img, 1);

	%point1_img_x = getWord(%point1_img, 0);
	%point1_img_y = getWord(%point1_img, 1);

	%point_img_d_x = %point1_img_x - %point0_img_x;
	%point_img_d_y = %point1_img_y - %point0_img_y;

	%y_diff_scale = mFloatLength((%x_diff / %point_diff_x) * (%point_img_d_x) + %point0_img_x, 0);
	%x_diff_scale = mFloatLength((%y_diff / %point_diff_y) * (%point_img_d_y) + %point0_img_y, 0);

	//swap x and y when drawing
	return (%y_diff_scale - 7) SPC (%x_diff_scale - 53);
}

function survival_map_on(%pressed)
{
	if(%pressed)
	{
		cancel($survival_map_blink_schedule);
		%stime = getSimTime();


		//double tap registered
		if((%stime - $survival_map_last_press_time) <= $survival_map_doubletap_time)
		{
			SurvivalMap.setBitmap("Add-ons/Client_Survival_Map/survival_map_labeled.png");
			$survival_map_ignore_depress = 1;
		}
		else
			SurvivalMap.setBitmap("Add-ons/Client_Survival_Map/survival_map.png");

		$survival_map_last_press_time = %stime;

		adjustSurvivalMapPos();
		SurvivalMap.setVisible(1);
		survival_map_update_loc();
	}

	else
	{
		if($survival_map_ignore_depress)
		{
			$survival_map_ignore_depress = 0;
			return;
		}

		$survival_map_ignore_depress = 0;
		SurvivalMap.setVisible(0);
		cancel($survival_map_blink_schedule);
	}
}

function survival_map_update_loc()
{
	%sc = serverConnection;

	if(!isObject(%sc) || !isObject(%scgco = %sc.getControlObject()))
	{
		//no longer in-game
		SurvivalMapLocationDot.setVisible(0);
		SurvivalMapDirDot.setVisible(0);

		for(%a = 0; %a < $survival_map_dirdotCount; %a++)
			if(isObject(%d = $survival_map_dirdot[%a]))
				%d.setVisible(0);

		return;
	}

	//check if player has a valid position
	if((%pos = %scgco.getPosition()) !$= "")
	{
		$SurvivalMap_last_good_position = %pos;

		//unit vector of the player's direction
		$SurvivalMap_last_good_direction = %forvector = %scgco.getForwardVector();

		SurvivalMapLocationDot.setText("\c2.");
		%dotPos = survival_getDotPos(%pos);
		SurvivalMapLocationDot.position = %dotpos;

		SurvivalMapLocationDot.setVisible(1);
		SurvivalMapLocationDot.schedule(400, setVisible, 0);

		//I have no idea why putting this at -135 degrees made it
		//inaccurate by 90 degrees

		%forvector_rot = rotatePointXY(%forvector, -45);

		//in a vehicle, the Z component has value other than 0.
		//take out Z component and renormalize vector
		%forvector_rot = VectorNormalize(getWord(%forvector_rot, 0) SPC getWord(%forvector_rot, 1));

		//center the small dir dot over the location dot
		%dirdot_x = getWord(%dotPos, 0) + 3.5;
		%dirdot_y = getWord(%dotPos, 1) + 26.75;

		
		%dirdot_x += getWord(%forvector_rot, 1) * 4;
		%dirdot_y += getWord(%forvector_rot, 0) * 4;

		SurvivalMapDirDot.position = mFloatLength(%dirdot_x, 0) SPC mFloatLength(%dirdot_y, 0);
		SurvivalMapDirDot.setVisible(1);
		SurvivalMapDirDot.schedule(400, setVisible, 0);

		for(%a = 0; %a < $survival_map_dirdotCount; %a++)
		{
			if(isObject(%d = $survival_map_dirdot[%a]))
			{
				%forvector_rot = rotatePointXY(%forvector, 0);
				%factor = (%a+1);
				%factorScalar = 50;
				if(%a > 1)
					%factor = mPow(%a + 1, 1.6);

				%vmult = vectorScale(%forvector_rot, (%factor) * %factorScalar);
				%thisDirDotPos = survival_getDotPos(vectorAdd(%pos, %vmult));

				%dirdot_x = getWord(%thisDirDotPos, 0) + 3.5;
				%dirdot_y = getWord(%thisDirDotPos, 1) + 26.75;

				%d.position =  mFloatLength(%dirdot_x, 0) SPC mFloatLength(%dirdot_y, 0);

				%d.schedule(0   + ((%a+1) * 25), setVisible, 1);
				%d.schedule(250 + ((%a+1) * 25), setVisible, 0);
			}
		}
	}

	else
	{
		//no valid position, so make dots disappear
		SurvivalMapLocationDot.setVisible(0);
		SurvivalMapDirDot.setVisible(0);
	}

	$survival_map_blink_schedule = schedule(500, 0, survival_map_update_loc);
}